//
// PatchDocument.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

/** A JSONPatch document as defined by RFC 6902 */
public struct PatchDocument: Codable, JSONEncodable, Hashable {

    public enum Op: String, Codable, CaseIterable {
        case add = "add"
        case remove = "remove"
        case replace = "replace"
        case move = "move"
        case copy = "copy"
        case test = "test"
    }
    /** The operation to be performed */
    public var op: Op
    /** A JSON-Pointer */
    public var path: String
    /** The value to be used within the operations. */
    public var value: String?
    /** A string containing a JSON Pointer value. */
    public var from: String?

    public init(op: Op, path: String, value: String? = nil, from: String? = nil) {
        self.op = op
        self.path = path
        self.value = value
        self.from = from
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case op
        case path
        case value
        case from
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encode(op, forKey: .op)
        try container.encode(path, forKey: .path)
        try container.encodeIfPresent(value, forKey: .value)
        try container.encodeIfPresent(from, forKey: .from)
    }
}

